
import com.ewon.ewonitf.IOServer;
import com.ewon.ewonitf.IOTag;
import com.ewon.ewonitf.IOValue;
import java.util.Random;

  public class IOserver extends IOServer implements Runnable {
    
   //Global variables for Tank
   private IOTag Tk_Debit_In;
   private IOTag Tk_Debit_Out;
   private IOTag Tk_Full;
   private IOTag Tk_Empty;
   private IOTag Tk_Pump_Start;
   private IOTag Tk_Valve_In;
   private IOTag Tk_Level;
   //
   //Global variables for Electric meter
   private IOTag Em_Kw;
   private IOTag Em_Consumption;
   private IOTag Em_Reset;
   //
   //Global variables for Gas meter
   private IOTag Gm_m3;
   private IOTag Gm_Consumption;
   private IOTag Gm_Reset;
   //
   //Global variables for Water meter
   private IOTag Wm_m3;
   private IOTag Wm_Consumption;
   private IOTag Wm_Reset;

      
         
   public void onRegister() throws Exception
   {
       //setJavaReplyTimeout(1000000);   //Let Java freeze the eWON while debugging.
   }
      
    public IOserver()
   {
      super();      
      setServerName("TAG_Sim");
       setTagHelper("{\"topic\":{ \"A\":{},\"B\":{}}}");
      
    
      Thread t=new Thread(this);
      t.start();
   }
       
    public void onPassConfig(boolean applyConfig, boolean checkConfig) throws Exception 
    {
        //Executed when passing global config (System Setup \ IOServer)
        System.out.println("DEBUG (onPassConfig): test param = " + getConfigParam("test","blabla"));
    
 
          
    }
 
    public IOValue onGetIo(IOTag ioTag)
    {
        //To set initial value
        IOValue _value = new IOValue(IOValue.DATATYPE_FLOAT32);
        _value.setFloat32(0);
        
        System.out.println("DEBUG (onGetIo): Tag= " + ioTag.getIoName());
        
        return _value;
        
    }
           
    public IOTag onGetIoInfo(String topicName, String ioName) throws Exception {
      
        //To validate Topic and Address of Tag and set its default type of value
        IOTag ioTag = null;
   
      if (!topicName.equals("A") && !topicName.equals("B"))
         throw new Exception("invalid Topic");
      //To validate Address of Tag and set its default type of value for Tank
      if (ioName.equals("Tk_Level") || ioName.equals("Tk_Debit_In") || ioName.equals("Tk_Debit_Out"))
         ioTag = new IOTag(topicName, ioName, IOValue.DATATYPE_FLOAT32, true);
      else if (ioName.equals("Tk_Full") || ioName.equals("Tk_Empty") || ioName.equals("Tk_Pump_Start") || ioName.equals("Tk_Valve_In"))
         ioTag = new IOTag(topicName, ioName, IOValue.DATATYPE_BOOLEAN, true);
      //
      //To validate Address of Tag and set its default type of value for Electric meter
        if (ioName.equals("Em_Kw") || ioName.equals("Em_Consumption"))
         ioTag = new IOTag(topicName, ioName, IOValue.DATATYPE_FLOAT32, true);
      else if (ioName.equals("Em_Reset"))
         ioTag = new IOTag(topicName, ioName, IOValue.DATATYPE_BOOLEAN, true);
      //
      //To validate Address of Tag and set its default type of value for Gas meter
        if (ioName.equals("Gm_m3") || ioName.equals("Gm_Consumption"))
         ioTag = new IOTag(topicName, ioName, IOValue.DATATYPE_FLOAT32, true);
      else if (ioName.equals("Gm_Reset"))
         ioTag = new IOTag(topicName, ioName, IOValue.DATATYPE_BOOLEAN, true);
      //
      //To validate Address of Tag and set its default type of value for Water meter
        if (ioName.equals("Wm_m3") || ioName.equals("Wm_Consumption"))
         ioTag = new IOTag(topicName, ioName, IOValue.DATATYPE_FLOAT32, true);
      else if (ioName.equals("Wm_Reset"))
         ioTag = new IOTag(topicName, ioName, IOValue.DATATYPE_BOOLEAN, true);
        
        
      if (ioTag == null)
         throw new Exception("invalid ioname");
      
      //if you don't want the tag to have an initial quality == GOOD
      //ioTag.setQuality(IOTag.QUALITY_BAD);
      
      return ioTag;
   }


     public void onAdviseIo(IOTag ioTag) throws Exception 
     {    
         //Tag has been added and validated.
         //Store the tag internally in your IO server and monitor it
         if (ioTag.getIoName().equals("Tk_Level"))
         Tk_Level = ioTag;
      else if (ioTag.getIoName().equals("Tk_Debit_In"))
         Tk_Debit_In = ioTag;
      else if (ioTag.getIoName().equals("Tk_Debit_Out"))
         Tk_Debit_Out = ioTag;
      else if (ioTag.getIoName().equals("Tk_Full"))
         Tk_Full = ioTag;
      else if (ioTag.getIoName().equals("Tk_Empty"))
         Tk_Empty = ioTag; 
      else if (ioTag.getIoName().equals("Tk_Pump_Start"))
         Tk_Pump_Start = ioTag;
      else if (ioTag.getIoName().equals("Tk_Valve_In"))
         Tk_Valve_In = ioTag;
         
      else if (ioTag.getIoName().equals("Em_Kw"))
         Em_Kw = ioTag;
      else if (ioTag.getIoName().equals("Em_Consumption"))
         Em_Consumption = ioTag;
      else if (ioTag.getIoName().equals("Em_Reset"))
         Em_Reset = ioTag;
         
      else if (ioTag.getIoName().equals("Gm_m3"))
         Gm_m3 = ioTag;
      else if (ioTag.getIoName().equals("Gm_Consumption"))
         Gm_Consumption = ioTag;
      else if (ioTag.getIoName().equals("Gm_Reset"))
         Gm_Reset = ioTag;
         
      else if (ioTag.getIoName().equals("Wm_m3"))
         Wm_m3 = ioTag;
      else if (ioTag.getIoName().equals("Wm_Consumption"))
         Wm_Consumption = ioTag;
      else if (ioTag.getIoName().equals("Wm_Reset"))
         Wm_Reset = ioTag;
         
     }

     public void onUnadviseIo(IOTag ioTag) throws Exception 
     {
         //Tag has been removed from Tags list
         //Remove the tag from your IO server and monitor it
         if (ioTag.getIoName().equals("Tk_Level"))
         Tk_Level = null;
      else if (ioTag.getIoName().equals("Tk_Debit_In"))
         Tk_Debit_In = null;
      else if (ioTag.getIoName().equals("Tk_Debit_Out"))
         Tk_Debit_Out = null;
      else if (ioTag.getIoName().equals("Tk_Full"))
         Tk_Full = null;
      else if (ioTag.getIoName().equals("Tk_Empty"))
         Tk_Empty = null; 
      else if (ioTag.getIoName().equals("Tk_Pump_Start"))
         Tk_Pump_Start = null;
      else if (ioTag.getIoName().equals("Tk_Valve_In"))
         Tk_Pump_Start = null;
         
      else if (ioTag.getIoName().equals("Em_Kw"))
         Em_Kw = ioTag;
      else if (ioTag.getIoName().equals("Em_Consumption"))
         Em_Consumption = ioTag;
      else if (ioTag.getIoName().equals("Em_Reset"))
         Em_Reset = ioTag;
         
      else if (ioTag.getIoName().equals("Gm_m3"))
         Gm_m3 = ioTag;
      else if (ioTag.getIoName().equals("Gm_Consumption"))
         Gm_Consumption = ioTag;
      else if (ioTag.getIoName().equals("Gm_Reset"))
         Gm_Reset = ioTag;
         
      else if (ioTag.getIoName().equals("Wm_m3"))
         Wm_m3 = ioTag;
      else if (ioTag.getIoName().equals("Wm_Consumption"))
         Wm_Consumption = ioTag;
      else if (ioTag.getIoName().equals("Wm_Reset"))
         Wm_Reset = ioTag;
        
     }
   
     public void onPutIo(IOTag ioTag, IOValue ioData) throws Exception
     {
         //User writes a new value to the Tag (Web page, Modbus,...)
         ioTag.updateTag(ioData);
      postIoChange(ioTag);
         System.out.println("DEBUG (onPutIo): Tag= " + ioTag.getIoName() + ", value= " + ioData.getFloat32());
     }         
      
     public void run()
     {            
         
      try
      {
           
         while (true)
         {
            Thread.sleep(1000);
         Random rand = new Random();

        // random value for tank
        int  n = rand.nextInt(100) + 400;
        float Debit_in=0;
        float Debit_out=0;
        
        // Random value for Electric consumtion
        int  Kw_rand_int = rand.nextInt(500) + 2500;
        float Kw_H=((float)Kw_rand_int/1000);
        
        // Random value for Gas consumtion based on 5 m³/day
        int  Gas_rand_int = rand.nextInt(500) + 4500;
        float Gas_m3=((float)Gas_rand_int*10/(24));
        
        // Random value for Water consumtion based on 90 m³/year
        int  Water_rand_int = rand.nextInt(10000) + 80000;
        float Water_m3=((float)Water_rand_int/(24));
           
            try
            {   
              // Electric consumption  
              if (Em_Kw != null) {                
                   Em_Kw.setValueFloat32((float)(Kw_H));
                   postIoChange(Em_Kw);                  
               }
              if (Em_Consumption != null) {                
                   Em_Consumption.setValueFloat32((float)(Em_Consumption.getValueFloat32() + Kw_H/3600));
                   postIoChange(Em_Consumption);                  
               }
              
              if (Em_Reset != null & Em_Reset.getValueBoolean() == true) {                
                   Em_Consumption.setValueFloat32((float)(0));
                   postIoChange(Em_Consumption);
                   Em_Reset.setValueBoolean(false);
                   postIoChange(Em_Reset);
               }
              //***********************************************
              
              // Gas consumption  
              if (Gm_m3 != null) {                
                   Gm_m3.setValueFloat32((float)(Gas_m3/1000));
                   postIoChange(Gm_m3);                  
               }
              if (Gm_Consumption != null) {                
                   Gm_Consumption.setValueFloat32((float)(Gm_Consumption.getValueFloat32() + Gas_m3/1000));
                   postIoChange(Gm_Consumption);                  
               }
              
              if (Gm_Reset != null & Gm_Reset.getValueBoolean() == true) {                
                   Gm_Consumption.setValueFloat32((float)(0));
                   postIoChange(Gm_Consumption);
                   Gm_Reset.setValueBoolean(false);
                   postIoChange(Gm_Reset);
               }
              //*********************************************** 
              
               // Water consumption  
              if (Wm_m3 != null) {                
                   Wm_m3.setValueFloat32((float)(Water_m3/1000));
                   postIoChange(Wm_m3);                  
               }
              if (Wm_Consumption != null) {                
                   Wm_Consumption.setValueFloat32((float)(Wm_Consumption.getValueFloat32() + Water_m3/1000));
                   postIoChange(Wm_Consumption);                  
               }
              
              if (Wm_Reset != null & Wm_Reset.getValueBoolean() == true) {                
                   Wm_Consumption.setValueFloat32((float)(0));
                   postIoChange(Wm_Consumption);
                   Wm_Reset.setValueBoolean(false);
                   postIoChange(Wm_Reset);
               }
              //***********************************************
              
              // Tank management
               if (Tk_Valve_In != null) {
                    if (Tk_Valve_In.getValueBoolean() == true) {
                    Debit_in = (float) n/10;
                  } 
               }
               if (Tk_Debit_In != null) {                
                    Tk_Debit_In.setValueFloat32((float)(Debit_in));
                    postIoChange(Tk_Debit_In);                  
               }
                             
                if (Tk_Pump_Start != null) {
                    if (Tk_Level.getValueFloat32()>1000) Tk_Pump_Start.setValueBoolean((boolean)(true));
                    if (Tk_Level.getValueFloat32()< 20) Tk_Pump_Start.setValueBoolean((boolean)(false));
                    postIoChange(Tk_Pump_Start);
                    if (Tk_Pump_Start.getValueBoolean() == true){
                        Debit_out=100;
                    }
                    else {
                        Debit_out=0;
                    }
               }
                
               if (Tk_Level != null) {                        
                    if (Tk_Level.getValueFloat32() == 0) {                
                          Tk_Valve_In.setValueBoolean(true);
                          postIoChange(Tk_Valve_In);                  
                    }
                    Tk_Level.setValueFloat32((float)(Tk_Level.getValueFloat32()+ Debit_in/60-Debit_out/60));
                    postIoChange(Tk_Level);
               }
               
               if (Tk_Debit_Out != null) {                
                    Tk_Debit_Out.setValueFloat32((float)(Debit_out));
                    postIoChange(Tk_Debit_Out);                  
               }
               
              if (Tk_Empty != null) { 
                  if (Tk_Level.getValueFloat32()<100){
                    Tk_Empty.setValueBoolean((boolean)(true));
                  }
                  else {
                    Tk_Empty.setValueBoolean((boolean)(false));  
                  }                      
                    postIoChange(Tk_Empty);                  
               } 
              
              if (Tk_Full != null) { 
                  if (Tk_Level.getValueFloat32()>900){
                    Tk_Full.setValueBoolean((boolean)(true));
                  }
                  else {
                    Tk_Full.setValueBoolean((boolean)(false));  
                  }                      
                    postIoChange(Tk_Full);                  
               }
               //***********************************************              
            }
            catch (Exception e)
            {
               System.out.println("Tag_Sim : "+e.getMessage());
            }
         }
      }
      catch (Exception e)
      {
        System.out.println("Tag_Sim : "+e.getMessage());
      
     }
     }  
   
  }
  
    

